package org.processmining.divideandconquer.plugins;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.divideandconquer.algorithms.DrFurbyAlgorithm;
import org.processmining.divideandconquer.help.DrFurbyHelp;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;

@Plugin(name = "Classify with DrFurby Classifier", parameterLabels = { "Training Log", "Test Log" }, returnLabels = { "Test Log with DrFurby Classification" }, returnTypes = {
		XLog.class }, help = DrFurbyHelp.TEXT)
public class DrFurbyPlugin extends DrFurbyAlgorithm {

	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Default", requiredParameterLabels = { 0, 1 })
	public XLog run(final UIPluginContext context, final XLog trainingLog, final XLog testLog) {
		return apply(context, trainingLog, testLog);
	}
	
}
