package org.processmining.extensions;

import java.net.URI;

import org.deckfour.xes.extension.XExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttributable;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XAttributeLiteral;

/**
 * 
 * @author hverbeek
 * @deprecated Please use org.processmining.logdecomposer.extensions.XClassExtension instead.
 */
@Deprecated
public class XClassExtension extends XExtension {

	private static final long serialVersionUID = -3947332482179571465L;

	public static final URI EXTENSION_URI = URI
			.create("http://www.xes-standard.org/class.xesext");

	public static final String KEY_EVENTID = "class:eventid";
	public static final String KEY_TRACEID = "class:traceid";

	public static XAttributeLiteral ATTR_EVENTID;
	public static XAttributeLiteral ATTR_TRACEID;

	private transient static XClassExtension singleton = new XClassExtension();

	public static XClassExtension instance() {
		return singleton;
	}

	private Object readResolve() {
		return singleton;
	}

	private XClassExtension() {
		super("Class", "class", EXTENSION_URI);
		XFactory factory = XFactoryRegistry.instance().currentDefault();
		ATTR_EVENTID = factory.createAttributeLiteral(KEY_EVENTID, "__INVALID__",
				this);
		this.eventAttributes.add((XAttribute) ATTR_EVENTID.clone());
		ATTR_TRACEID = factory.createAttributeLiteral(KEY_TRACEID, "__INVALID__",
				this);
		this.eventAttributes.add((XAttribute) ATTR_TRACEID.clone());
	}

	public String extractEventId(XAttributable element) {
		XAttribute attribute = element.getAttributes().get(KEY_EVENTID);
		if (attribute == null) {
			return null;
		} else {
			return ((XAttributeLiteral) attribute).getValue();
		}
	}

	public void assignEventId(XAttributable element, String id) {
		if (id != null && id.trim().length() > 0) {
			XAttributeLiteral attr = (XAttributeLiteral) ATTR_EVENTID.clone();
			attr.setValue(id);
			element.getAttributes().put(KEY_EVENTID, attr);
		}
	}

	public String extractTraceId(XAttributable element) {
		XAttribute attribute = element.getAttributes().get(KEY_TRACEID);
		if (attribute == null) {
			return null;
		} else {
			return ((XAttributeLiteral) attribute).getValue();
		}
	}

	public void assignTraceId(XAttributable element, String id) {
		if (id != null && id.trim().length() > 0) {
			XAttributeLiteral attr = (XAttributeLiteral) ATTR_TRACEID.clone();
			attr.setValue(id);
			element.getAttributes().put(KEY_TRACEID, attr);
		}
	}
}
