package org.processmining.plugins;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.util.Pair;
import org.processmining.models.AcceptingPetriNet;
import org.processmining.models.AcceptingPetriNetArray;
import org.processmining.models.LogAlignment;
import org.processmining.models.LogAlignmentArray;
import org.processmining.models.TraceAlignment;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.impl.DivideAndConquerFactory;
import org.processmining.plugins.petrinet.replayresult.StepTypes;

/**
 * 
 * @author hverbeek
 * @deprecated Please use org.processmining.logalignment.plugins.FilterLogAlignmentPlugin instead.
 */
@Deprecated
//Plugin(name = "Filter Log Alignments", parameterLabels = { "Log Alignment Array", "Accepting Petri Net Array" }, returnLabels = { "Log Alignment Array" }, returnTypes = { LogAlignmentArray.class })
public class FilterLogAlignmentPlugin {

//	UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
//	PluginVariant(variantLabel = "Filter Log Alignments, Default", requiredParameterLabels = { 0, 1 })
	public LogAlignmentArray filterDefault(PluginContext context, LogAlignmentArray alignments,
			AcceptingPetriNetArray nets) {
		return filterPrivate(context, alignments, nets);
	}

	private LogAlignmentArray filterPrivate(PluginContext context, LogAlignmentArray alignments,
			AcceptingPetriNetArray nets) {
		LogAlignmentArray filteredAlignments = DivideAndConquerFactory.createLogAlignmentArray();
		filteredAlignments.init();
		for (int index = 0; index < alignments.getSize(); index++) {
			if (index < nets.getSize()) {
				LogAlignment alignment = alignments.getAlignment(index);
				AcceptingPetriNet net = nets.getNet(index);
				Set<String> transitionIds = new HashSet<String>();
				for (Transition transition : net.getNet().getTransitions()) {
					transitionIds.add(transition.getLabel());
				}
				filteredAlignments.addAlignment(filterPrivate(alignment, transitionIds));
			}
		}
		return filteredAlignments;
	}

	private LogAlignment filterPrivate(LogAlignment alignments, Set<String> transitionIds) {
		LogAlignment filteredAlignments = DivideAndConquerFactory.createLogAlignment();
		filteredAlignments.init();
		filteredAlignments.setCluster(alignments.getCluster());
		for (List<XEventClass> trace : alignments.getAlignments().keySet()) {
			TraceAlignment filteredAlignment = DivideAndConquerFactory.createTraceAlignment();
			filteredAlignment.init();
			TraceAlignment alignment = alignments.getAlignment(trace);
			for (int index = 0; index < alignment.getSize(); index++) {
				Pair<StepTypes, Pair<XEventClass, String>> step = alignment.getLegalMoves().get(index);
				if (transitionIds.contains(step.getSecond().getSecond()) || alignments.getCluster().contains(step.getSecond().getFirst())) {
					filteredAlignment.addLegalMove(step.getFirst(), step.getSecond().getFirst(), step.getSecond()
							.getSecond());
				}
			}
			filteredAlignment.setCosts(alignment.getCosts());
			filteredAlignments.putAlignment(trace, filteredAlignment);
		}
		return filteredAlignments;
	}
}
