package org.processmining.plugins;

import java.util.HashSet;
import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.AcceptingPetriNet;
import org.processmining.models.AcceptingPetriNetArray;
import org.processmining.models.ActivityClusterArray;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.impl.DivideAndConquerFactory;

/**
 * 
 * @author hverbeek
 * @deprecated Please use org.processmining.acceptingpetrinetdecomposer.plugins.ValidateActivityClusterArrayPlugin instead.
 */
@Deprecated
//Plugin(name = "Validate Clusters", parameterLabels = { "Activity Cluster Array", "Accepting Petri Net" }, returnLabels = { "Valid Activity Cluster Array" }, returnTypes = { ActivityClusterArray.class })
public class ValidateActivityClusterArrayPlugin {

//	UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
//	PluginVariant(variantLabel = "Validate Clusters, Default", requiredParameterLabels = { 0, 1 })
	public ActivityClusterArray validateDefault(PluginContext context, ActivityClusterArray clusters,
			AcceptingPetriNetArray nets) {
		return validatePrivate(context, clusters, nets);
	}
	
	private ActivityClusterArray validatePrivate(PluginContext context, ActivityClusterArray clusters,
			AcceptingPetriNetArray nets) {
		ActivityClusterArray validatedClusters = DivideAndConquerFactory.createActivityClusterArray();
		validatedClusters.init(clusters);
		Set<Integer> invalidIndices = new HashSet<Integer>();
		for (int i = 0; i < clusters.getClusters().size(); i++) {
			if (!invalidIndices.contains(i)) {
				Set<XEventClass> cluster = new HashSet<XEventClass>(clusters.getCluster(i));
				Set<String> placeIds = getPlaceIds(nets.getNet(i));
				boolean progress = true;
				while (progress) {
					progress = false;
					for (int j = i + 1; j < nets.getSize(); j++) {
						if (!invalidIndices.contains(j)) {
							Set<String> otherPlaceIds = getPlaceIds(nets.getNet(j));
							otherPlaceIds.retainAll(placeIds);
							if (!otherPlaceIds.isEmpty()) {
								progress = true;
								invalidIndices.add(j);
								placeIds.addAll(getPlaceIds(nets.getNet(j)));
								cluster.addAll(clusters.getCluster(j));
							}
						}
					}
				}
				validatedClusters.addCluster(cluster);
			}
		}
		return validatedClusters;
	}

	private Set<String> getPlaceIds(AcceptingPetriNet net) {
		Set<String> placeIds = new HashSet<String>();
		for (Place place : net.getNet().getPlaces()) {
			placeIds.add(place.getLabel());
		}
		return placeIds;
	}
}
